QGIS Application - Bug report #9319
copy of QgsExpression causes segfault
2014-01-10 09:41 AM - Vincent Mora

Status: Closed

Priority: High

Assignee: Vincent Mora

Category: Expressions

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corruptsdata: Copied to github as #: 17926
Description

The default copy and assigment operator of QgsExpression causes segfault (multiple delete) if used.

Since the copy and assigment operator are not used anywhere | just made the class non-copyable (so the future developers won't get
caught like | was)

The pull request is there: https:/github.com/qgis/QGIS/pull/1075

Associated revisions

Revision 37ba8e41 - 2014-10-22 06:03 PM - Martin Dobias

Fix #9319 (copy of QgsExpression crashes)

Disabled the copy constructor for now (later we may introduce implicit sharing)

History

#1 - 2014-02-07 05:54 AM - Giovanni Manghi
- Priority changed from Normal to High

#2 - 2014-02-08 04:07 AM - Jiirgen Fischer

- Status changed from Open to Closed

pull request merged in commit:3568fe761

#3 - 2014-07-24 01:21 AM - Matthias Kuhn

- Status changed from Closed to Reopened

I can still copy and | get the same crash.

QgsExpression* exp = new QgsExpression( "1");
QgsExpression* exp2 = new QgsExpression( exp );

delete (exp);
delete (exp2);
https://github.com/qgis/QGIS/pull/1075

Proposal: make this class implicitly shared.

#4 - 2014-10-22 09:04 AM - Martin Dobias
- Status changed from Reopened to Closed

Fixed in changeset commit:"37ba8e41871eb12d0b76c8892465706560222623".
http://qt-project.org/doc/qt-4.8/implicit-sharing.html#implicitly-shared

